<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
    <style>
      .error {
        color: red;
      }
    </style>
  </head>
  <body>
    <script>
      /**
       * Написати функцію валідації поштової адреси
       * - не менше 5 символів
       * - наявність @
       * - закінчується на .com
       *
       * Прокидувати помилку для кожної валідації, якщо вона не виконується
       * Повертати true у функції, якщо валідація проходить
       *
       */
      // классы для ошибок

      class InvalidLengthError extends Error {
        constructor(name, message) {
          super();
          this.name = 'InvalidLengthError';
          this.message = 'email length mast be equal 5 o more';
        }
      }
      class AttIsPresentError extends Error {
        constructor(name, message) {
          super();
          this.name = 'AttIsPresentError';
          this.message = 'email mast be @';
        }
      }
      class DomainEmailError extends Error {
        constructor(name, message) {
          super();
          this.name = 'DomainEmailError';
          this.message = 'email mast be end .com';
        }
      }
      function validateEmail (email) {
        if(email.length < 5){
          throw new InvalidLengthError();
        } else if (!email.includes('@')){
          throw new AttIsPresentError();
        } else if(email.endsWith('.com')){
          throw new DomainEmailError();
        }
        return true;
      }
      
      function showError(err) {
        let errorBlock = document.createElement('div');
        errorBlock.innerHTML = `<h1>${err.name}</h1>
                                <p>${err.message}</p>`;
        errorBlock.className = 'error';
        document.body.append(errorBlock);
      }
      try {
        // validateEmail('danit@gmail.com');
        validateEmail('danit@gmail.com');
      }catch(err) {
        showError(err);        
      }
    </script>
  </body>
</html>
